import cf
import numpy
import os

def test(chunk_sizes=(17, 34, 60, 300, 100000)):
    
    print '----------------------------------------------------------'
    print 'cf.collapse'
    print '----------------------------------------------------------'
    # Save original chunksize
    original_chunksize = cf.CHUNKSIZE()

    filename = os.path.join(os.path.dirname(os.path.abspath(__file__)),
                            "test_file.nc")

    for squeeze in (True, False):
        for missing_data in (True, False):
            for chunk in chunk_sizes:
            
                cf.CHUNKSIZE(chunk)
                
                f = cf.read(filename, squeeze=squeeze)[0]
        
                ## Dimension coordinates
                #dim0 = cf.Coordinate(data=cf.Data(numpy.arange(10.), 'degrees'))
                #dim0.standard_name = 'grid_latitude'
                # 
                #dim1 = cf.Coordinate(data=cf.Data(numpy.arange(9.) + 20, 'degrees'))
                #dim1.standard_name = 'grid_longitude'
                #dim1.Data[-1] += 5
                #bounds = cf.Data(numpy.array([dim1.Data.array-0.5, dim1.Data.array+0.5]).transpose((1,0)))
                #bounds[-2,1] = 30
                #bounds[-1,:] = [30, 36]
                #dim1.insert_bounds(cf.CoordinateBounds(data=bounds))
                #
                #dim2 = cf.Coordinate(data=cf.Data(1.5), bounds=cf.Data([1, 2.]))
                #dim2.standard_name = 'atmosphere_hybrid_height_coordinate'
                #
                ## Auxiliary coordinates
                #aux0 = cf.Coordinate(data=cf.Data(10., 'm'))
                #aux0.id = 'atmosphere_hybrid_height_coordinate_ak'
                #aux0.insert_bounds(cf.Data([5, 15.], aux0.Units))
                #
                #aux1 = cf.Coordinate(data=cf.Data(20.))
                #aux1.id = 'atmosphere_hybrid_height_coordinate_bk'
                #aux1.insert_bounds(cf.Data([14, 26.]))
                #
                #aux2 = cf.Coordinate(data=cf.Data(numpy.arange(-45, 45, dtype='int32').reshape(10, 9),
                #                                  units='degree_N'))
                #aux2.standard_name = 'latitude'
                #
                #aux3 = cf.Coordinate(data=cf.Data(numpy.arange(60, 150, dtype='int32').reshape(9, 10),
                #                                  units='degreesE'))
                #aux3.standard_name = 'longitude'
                #
                ## Cell measures
                #cm0 = cf.CellMeasure(data=cf.Data(1+numpy.arange(90.).reshape(9, 10)*1234, 'km 2'))
                #cm0.measure = 'area'
                #
                ## Transforms
                #trans0 = cf.Transform(grid_mapping_name='rotated_latitude_longitude',
                #                      grid_north_pole_latitude=38.0,
                #                      grid_north_pole_longitude=190.0,
                #                      inputs=('grid_latitude', 'grid_longitude'))
                #            
                ## Data          
                #data = cf.Data(numpy.arange(90.).reshape(10, 9), 'm s-1')
                #
                ## Domain
                #domain = cf.Domain(dim=(dim0, dim1, dim2),
                #                   aux=[aux0, aux1, aux2, aux3],
                #                   cm={'cm0': cm0},
                #                   trans=(trans0,),
                #                   assign_axes={'aux0': ['dim2'],
                #                                'aux1': ['dim2'],
                #                                'aux3': ['dim1', 'dim0'],
                #                                'cm0' : ['dim1', 'dim0']},
                #                   )
                #
                #properties = {'standard_name': 'eastward_wind'}
                #
                #f = cf.Field(properties=properties, domain=domain, data=data) 
                #orog = f.copy()
                #orog.standard_name = 'surface_altitude'
                #orog.insert_data(cf.Data(f.array*2, 'm'))
                #orog.squeeze()
                #orog.remove_axes('dim2')
                #orog.transpose([1, 0])
                #orog.finalize()
                #t = cf.Transform(a='aux0', b='aux1', orog=orog,
                #                 standard_name='atmosphere_hybrid_height_coordinate')
                #
                #f.domain.insert_transform(t)
                #
                ## Ancillary variables
                #tmp = f.copy()
                #tmp.remove_items(role='t')
                #tmp.remove_item('aux0')
                #tmp.remove_item('atmosphere_hybrid_height_coordinate_bk')
                #
                #f.ancillary_variables = cf.AncillaryVariables()
                #
#               # print 'ANCILLARY 0'
                #g = tmp.copy()
                #g.transpose([1,0])
                #g.standard_name = 'ancillary0'
                #g *= 0.01
                #g.remove_axes(g.axes().difference(g.data_axes()))
                #f.ancillary_variables.append(g) 
#               # print g
                #
#               # print 'ANCILLARY 1'
                #g = tmp.copy()
                #g.standard_name = 'ancillary1'
                #g *= 0.01
                #g.remove_axes(g.axes().difference(g.data_axes()))
                #f.ancillary_variables.append(g) 
                #
#               # print 'ANCILLARY 2'
                #g = tmp.copy()
                #g = g.subspace[0]
                #g.squeeze()
                #g.standard_name = 'ancillary2'
                #g *= 0.001
                #g.remove_axes(g.axes().difference(g.data_axes()))
                #f.ancillary_variables.append(g)
                #
#               # print 'ANCILLARY 3'
                #g = tmp.copy()
                #g = g.subspace[..., 0]
                #g.squeeze()
                #g.standard_name = 'ancillary3'
                #g *= 0.001
                #g.remove_axes(g.axes().difference(g.data_axes()))
                #f.ancillary_variables.append(g)
                #
                #f.flag_values = [1,2,4]
                #f.flag_meanings = ['a', 'bb', 'ccc']
                #
                #cf.write(f, '~/cf-python/test/test_file.nc')
                #ff = cf.read('~/cf-python/test/test_file.nc', squeeze=True)[0]
        
                
                if missing_data:
                    for i in range(9):
                        f.subspace[..., [i, 9-i], i] = cf.masked
        
                print f
                print f.array                    
                print f.Data.dumpd()
                
                w = f.cm('area')
                w /= 10000.
                w = w.copy()
                w.transpose()
                w = w.array
                w = w.reshape(f.array.shape)
                if numpy.ma.is_masked(f.array):
                    w = numpy.ma.array(w, mask=f.array.mask)
                assert(w.shape == f.array.shape)
                   
                print '--------------------------------------------------------------------'
                print('Unweighted collapse, CHUNKSIZE=%s, missing_data=%s' %
                      (cf.CHUNKSIZE(), missing_data))
                print '--------------------------------------------------------------------'
                    
                method='mean'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.average(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                        
                method='max'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.amax(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                        
                method='min'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.amin(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                  
                method='mid_range'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.ptp(f.array, axis=axis) / 2.0
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                
                method='sum'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.sum(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.var(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None, unbiased=True)
                    expected = numpy.ma.var(f.array, axis=axis, ddof=1)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted unbiased %s over %s passed" % (method, repr(axes))
                
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None)
                    expected = numpy.ma.std(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted %s over %s passed" % (method, repr(axes))
                
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights=None, unbiased=True)
                    expected = numpy.ma.std(f.array, axis=axis, ddof=1)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Unweighted unbiased %s over %s passed" % (method, repr(axes))
                
                print '--------------------------------------------------------------------'
                print('Weighted collapse, CHUNKSIZE=%s, missing_data=%s' %
                      (cf.CHUNKSIZE(), missing_data))
                print '--------------------------------------------------------------------'
                    
                method='max'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.amax(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
                        
                method='min'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.amin(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
                  
                method='mid_range'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.ptp(f.array, axis=axis) / 2.0
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
                
                method='sum'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.sum(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
                
                method='mean'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.average(f.array, weights=w, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
        
                method='mean'
                for axes, axis, y in zip(('grid_latitude', 'grid_longitude',
                                          ['grid_longitude', 'grid_latitude'], None),
                                         (-2, -1, None, None),
                                         ('grid_lat', 'grid_longitude',
                                          ('grid_long', 'grid_latitude'),
                                          ('X', 'grid_latitude'))):
                    c = cf.collapse(f, method, axes=axes, weights=y)
                    expected = numpy.ma.average(f.array, weights=w, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
        
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY') 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    expected = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
        
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY', unbiased=True) 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
#                    print 'mean=', mean
#                    print 'sw=', sw
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    sw2      = numpy.ma.sum(w**2, axis=axis)
                    expected = (sw**2/((sw**2)-sw2))*variance 
#                    print 'sw2=', sw2
#                    print 'variance=', variance
#                    print  c.array
#                    print expected
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted unbiased %s over %s passed" % (method, repr(axes))
        
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY') 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    expected = variance**0.5
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted %s over %s passed" % (method, repr(axes))
        
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY', unbiased=True) 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    sw2      = numpy.ma.sum(w**2, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    variance *= sw**2/(sw**2-sw2)
                    expected = variance**0.5
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted unbiased %s over %s passed" % (method, repr(axes))
        
                print '--------------------------------------------------------------------'
                print('Weighted collapse, no cell measure, CHUNKSIZE=%s, missing_data=%s' %
                      (cf.CHUNKSIZE(), missing_data))
                print '--------------------------------------------------------------------'
        
                cm = f.remove_item('area')
        
                wlat = cf.tools.collapse.calc_weights(f.item('grid_latitude'),
                                                      infer_bounds=True).array
                wlon = cf.tools.collapse.calc_weights(f.item('grid_longitude'),
                                                      infer_bounds=True).array
        
                w0 = wlat.reshape(10, 1)
                w1 = wlon.reshape( 1, 9)
                w = w0*w1
                w = w.reshape(f.array.shape)
                assert(w.shape == f.array.shape)
              
                if numpy.ma.is_masked(f.array):
                    w = numpy.ma.array(w, mask=f.array.mask)
        
                method='max'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.amax(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
                        
                method='min'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.amin(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
                  
                method='mid_range'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.ptp(f.array, axis=axis) / 2.0
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
                
                method='sum'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.sum(f.array, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
                
                method='mean'
                for axes, axis, x in zip(('grid_latitude', 'grid_longitude',
                                          ['grid_longitude', 'grid_latitude'], None),
                                         (-2, -1, None, None),
                                         (wlat, wlon, w, w)):
                    c = cf.collapse(f, method, axes=axes, weights='XY')
                    expected = numpy.ma.average(f.array, weights=x, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
        
                method='mean'
                for axes, axis, x, y in zip(('grid_latitude', 'grid_longitude',
                                             ['grid_longitude', 'grid_latitude'], None),
                                            (-2, -1, None, None),
                                            (wlat, wlon, w, w),
                                            ('Y', 'X', 'XY', 'YX')):
                    c = cf.collapse(f, method, axes=axes, weights=y)
                    expected = numpy.ma.average(f.array, weights=x, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
        
                method='mean'
                for axes, axis, x, y in zip(('grid_latitude', 'grid_longitude',
                                             ['grid_longitude', 'grid_latitude'], None),
                                            (-2, -1, None, None),
                                            (wlat, wlon, w, w),
                                            ('grid_latitude', 'grid_longitude',
                                             ('grid_longitude', 'grid_latitude'),
                                             ('X', 'grid_latitude'))):
                    c = cf.collapse(f, method, axes=axes, weights=y)
                    expected = numpy.ma.average(f.array, weights=x, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
        
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY') 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    expected = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
        
                method='variance'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY', unbiased=True) 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
#                    print 'mean=', mean
#                    print 'sw=', sw
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    sw2      = numpy.ma.sum(w**2, axis=axis)
                    expected = (sw**2/((sw**2)-sw2))*variance 
#                    print 'sw2=', sw2
#                    print 'variance=', variance
#                    print  c.array
#                    print expected
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, unbiased %s over %s passed" % (method, repr(axes))
        
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY') 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    expected = variance**0.5
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, %s over %s passed" % (method, repr(axes))
        
                method='standard_deviation'
                for axes, axis in zip(('grid_latitude', 'grid_longitude',
                                       ['grid_longitude', 'grid_latitude'], None),
                                      (-2, -1, None, None)):
                    c = cf.collapse(f, method, axes=axes, weights='XY', unbiased=True) 
                    mean, sw = numpy.ma.average(f.array, weights=w, returned=True, axis=axis)
                    sw2      = numpy.ma.sum(w**2, axis=axis)
                    if axis is not None:
                        mean = numpy.expand_dims(mean, axis)
                    variance = numpy.ma.average((f.array-mean)**2, weights=w, axis=axis)
                    variance *= sw**2/(sw**2-sw2)
                    expected = variance**0.5
                    assert(numpy.ma.allclose(c.array.flatten(), expected))
                    print "Weighted, no cell measure, unbiased %s over %s passed" % (method, repr(axes))
        
                #axes=['grid_longitude', 'grid_latitude']
                #c = cf.collapse(f, 'mean', axes=axes, weights='XY')
                #
                #expected = numpy.ma.average(f.array, weights=w)
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Weighted mean over %s (no cell measure) passed" % repr(axes)
                #
                #cell_methods='grid_longitude: mean grid_latitude: max'
                #c = cf.collapse(f, cell_methods, weights='XY')
                #d = cf.collapse(f, 'mean', axes='grid_longitude', weights='XY')
                #expected = cf.collapse(d, 'max', axes='grid_latitude', weights='XY').array
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Weighted mean, max over %s (no cell measure) passed" % repr(cell_methods)
                #
                #f.domain.insert_cm(cm, axes=['dim1', 'dim0'])
                #
                #axes=['grid_longitude', 'grid_latitude']
                #c = cf.collapse(f, 'mean', axes=axes, weights='XY')
                #expected = numpy.ma.average(f.array, weights=w)
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Weighted mean over %s (with cell measure) passed" % repr(axes)
                #
                #axes=None
                #c = cf.collapse(f, 'variance', weights='XY')
                #mean, sw = numpy.ma.average(f.array, weights=w, returned=True)          
                #expected = numpy.ma.sum(w*(f.array-mean)**2)/sw #numpy.ma.sum(w)
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Weighted biased variance over %s passed" % repr(axes)
                #
                #axes=None
                #c = cf.collapse(f, 'variance', weights='XY', unbiased=True)
                #mean, sw = numpy.ma.average(f.array, weights=w, returned=True)
                #sw2 = numpy.sum(w**2)
                #expected = (sw/(sw**2-sw2))*numpy.sum(w*((f.array-mean)**2))
                #expected = (sw**2/(sw**2-sw2))*numpy.ma.average((f.array-mean)**2, weights=w)
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Weighted unbiased variance over %s passed" % repr(axes)
                #
                #print '--------------------------------------------------------------------'
                #print 'Cell measures weighted collapse'
                #print '--------------------------------------------------------------------'
                #
                #axes=['grid_longitude', 'grid_latitude']
                #c = cf.collapse(f, 'mean', axes=axes, weights='XY')
                #w = f.cm('area').copy()
                #w.transpose()
                #w = w.array
                #expected = numpy.ma.average(f.array, weights=w)
                #assert(numpy.ma.allclose(c.array.flatten(), expected))
                #print "Cell measures weighted mean over %s passed" % repr(axes)
                
                f.cell_methods = cf.CellMethods('grid_longitude: mean grid_latitude: max')
            #--- End: for
        #--- End: for
    #--- End: for
      
    # Reset chunk size
    cf.CHUNKSIZE(original_chunksize)

    print
    print '---------------------------------------------------------------------------'
    print 'All cf.collapse tests passed for cf version', cf.__version__
    print 'Running from', os.path.abspath(cf.__file__)
    print '---------------------------------------------------------------------------' 
    print 
#--- End: def

if __name__ == "__main__":
    test()
